/*	Fichero dialogobiestable.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Sabado 4-11-2006
*/


#ifndef _diabiestable_h
#define _diabiestable_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"

#include "dialogo.h"
#include "biestable.h"

/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {	
		ID_DIALOGO_BIESTABLE=8450	,
		ID_VOLTAJE_ACTIVACION_R 	,
		ID_VOLTAJE_ACTIVACION_S 	,
		ID_VOLTAJE_REPOSO_Q 		,
		ID_VOLTAJE_REPOSO_R 		,
		ID_VOLTAJE_REPOSO_S 		,
		ID_VOLTAJE_SALIDA_Q 		,
};

class DialogoBiestable : public Dialogo
{
	DECLARE_CLASS (DialogoBiestable)
	public: 
		DialogoBiestable ();
		DialogoBiestable ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_BIESTABLE,
							const wxString& titulo= wxT ("Configurar biestable"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
	private:
		
		/*	Estos nombres de variable no son del todo representativos,
			ya que el usuario puede invertir los valores y escribir que
			por ejemplo 0V es el voltaje que el pulsador emite cuando se
			pulsa. Se usan estos nombres porque por defecto se usaran
			0V para el reposo y "false" para el estado no-conectado*/
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];
		
		
		/*	Los controles. */
		
		wxBoxSizer *contenedorCentral;
		wxBoxSizer *contenedorR;
		wxBoxSizer *contenedorS;
		wxBoxSizer *contenedorQ;
		
		wxStaticText *lblReposoR;
		wxStaticText *lblVoltajeActivacionR;
		wxStaticText *lblVReposoS;
		wxStaticText *lblActivacionS;
		wxStaticText *lblReposoQ;
		wxStaticText *lblVoltajeSalidaQ;
		
		wxStaticLine *m_staticline2;
		
	    wxSpinCtrl *spnVReposoR;
	    wxSpinCtrl *spnVActivacionR;
	    wxSpinCtrl *spnVReposoS;
	    wxSpinCtrl *spnVActivacionS;
	    wxSpinCtrl *spnVReposoQ;
	    wxSpinCtrl *spnVActivacionQ;
			
};

#endif
