#include "dialogocontador.h"
#include "dialogo.h"
#include "constantes.h"

IMPLEMENT_CLASS (DialogoContador, Dialogo)
DialogoContador::DialogoContador()
{
	Init();
}

DialogoContador::DialogoContador ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoContador::Init()
{
	/*	Aqui se inicializan las variables */
	anchuraSpins=45;	
}


void DialogoContador::ConstruirControles()
{

  contenedorCentral = new wxBoxSizer(wxVERTICAL);
  
  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
  lblReposo = new wxStaticText(this, ID_STATIC, wxT("En reposo el contador devuelve"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  wxBoxSizer *contenedorSpinVSalidaReposo;
  contenedorSpinVSalidaReposo = new wxBoxSizer(wxVERTICAL);
  spnVSalidaReposo = new wxSpinCtrl(this, ID_VOLTAJE_SALIDA_REPOSO, wxT("0"), wxDefaultPosition, wxSize(anchuraSpins,-1), wxSP_ARROW_KEYS, 0, 10, 0);
       
  contenedorSpinVSalidaReposo->Add(spnVSalidaReposo, 0, wxALIGN_CENTER_VERTICAL|wxALL|wxALIGN_RIGHT, 5);
  contenedorReposo->Add(contenedorSpinVSalidaReposo, 1, wxEXPAND, 5);
  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
  wxBoxSizer *contenedorActivacion;
  contenedorActivacion = new wxBoxSizer(wxHORIZONTAL);
  lblActivacion = new wxStaticText(this, ID_STATIC, wxT("Al activarse el contador devuelve"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxALIGN_RIGHT, 5);
  wxBoxSizer *contenedorSpinVSalidaActivacion;
  contenedorSpinVSalidaActivacion = new wxBoxSizer(wxVERTICAL);
  spnVSalidaActivacion = new wxSpinCtrl(this, ID_VOLTAJE_SALIDA_ACTIVACION, wxT("9"), wxDefaultPosition, wxSize(anchuraSpins,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorSpinVSalidaActivacion->Add(spnVSalidaActivacion, 0, wxALL|wxALIGN_RIGHT, 5);
  contenedorActivacion->Add(contenedorSpinVSalidaActivacion, 1, wxEXPAND, 5);
  contenedorCentral->Add(contenedorActivacion, 1, wxEXPAND, 5);
  lnSeparador1 = new wxStaticLine(this, ID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL);
       
  contenedorCentral->Add(lnSeparador1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxEXPAND|wxALIGN_CENTER_VERTICAL, 5);
  m_staticText5 = new wxStaticText(this, ID_STATIC, wxT("El contador cuenta un pulso cuando en la entrada hay un cambio"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorCentral->Add(m_staticText5, 0, wxALL, 5);
  wxBoxSizer *contenedorCambioDeVoltaje;
  contenedorCambioDeVoltaje = new wxBoxSizer(wxHORIZONTAL);
  lblDe = new wxStaticText(this, ID_STATIC, wxT("De"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorCambioDeVoltaje->Add(lblDe, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVoltajeEntradaFlancoBajo = new wxSpinCtrl(this, ID_VOLTAJE_ENTRADA_FLANCO_BAJO, wxT("0"), wxDefaultPosition, wxSize(anchuraSpins,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorCambioDeVoltaje->Add(spnVoltajeEntradaFlancoBajo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblVolt = new wxStaticText(this, ID_STATIC, wxT("volt. a"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorCambioDeVoltaje->Add(lblVolt, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVoltajeEntradaFlancoAlto = new wxSpinCtrl(this, ID_VOLTAJE_ENTRADA_FLANCO_ALTO, wxT("9"), wxDefaultPosition, wxSize(anchuraSpins,-1), wxSP_ARROW_KEYS, 0, 10, 0);
       
  contenedorCambioDeVoltaje->Add(spnVoltajeEntradaFlancoAlto, 0, wxALL, 5);
  contenedorCentral->Add(contenedorCambioDeVoltaje, 1, wxALIGN_CENTER_HORIZONTAL, 5);
  lnSeparador2 = new wxStaticLine(this, ID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL);
       
  contenedorCentral->Add(lnSeparador2, 0, wxALL|wxEXPAND, 5);
  wxBoxSizer *contenedorNumPulsos;
  contenedorNumPulsos = new wxBoxSizer(wxHORIZONTAL);
  lblNumPulsos = new wxStaticText(this, ID_STATIC, wxT("Numero de pulsos a contar"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorNumPulsos->Add(lblNumPulsos, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnNumPulsos = new wxSpinCtrl(this, ID_NUM_PULSOS, wxT("10"), wxDefaultPosition, wxSize(anchuraSpins,-1), wxSP_ARROW_KEYS, 0, 100, 0);
       
  contenedorNumPulsos->Add(spnNumPulsos, 0, wxALL, 5);
  contenedorCentral->Add(contenedorNumPulsos, 1, wxALIGN_CENTER_HORIZONTAL, 5);
  
  
  ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoContador::getPropiedades ( Elemento* elemento )
{
	Contador* cont = (Contador*) elemento;
	TransferirDeNombreDeElementoAControl ( cont );	

	TransferirDeVoltajeASpin ( spnVoltajeEntradaFlancoBajo,
								cont->getVoltajeEntradaReposo() );
	TransferirDeVoltajeASpin ( spnVoltajeEntradaFlancoAlto,
								cont->getVoltajeEntradaActivacion() );

	TransferirDeVoltajeASpin ( spnVSalidaReposo,
								cont->getVoltajeSalidaReposo() );
	TransferirDeVoltajeASpin ( spnVSalidaActivacion,
								cont->getVoltajeSalidaActivacion() );

	spnNumPulsos->SetValue   ( cont->getMaxPulsos() );
}

void DialogoContador::setPropiedades ( Elemento* elemento )
{
	Contador* cont = (Contador*) elemento;
	TransferirDeControlANombreDeElemento ( cont );	
	TransferirDeVoltajeASpin ( spnVoltajeEntradaFlancoBajo,
								cont->getVoltajeEntradaReposo() );
	TransferirDeVoltajeASpin ( spnVoltajeEntradaFlancoAlto,
								cont->getVoltajeEntradaActivacion() );
	TransferirDeVoltajeASpin ( spnVSalidaReposo,
								cont->getVoltajeSalidaReposo() );
	TransferirDeVoltajeASpin ( spnVSalidaActivacion,
								cont->getVoltajeSalidaActivacion() );
	cont->setMaxPulsos 		 (spnNumPulsos->GetValue() );
	
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoContador::OnCReposoActualizado ( wxCommandEvent& evento )
{

}

void DialogoContador::OnCActivacionActualizado ( wxCommandEvent& evento )
{

}

BEGIN_EVENT_TABLE(DialogoContador, wxDialog)
	//EVT_UPDATE_UI( ID_MAGNETISMO_REPOSO, DialogoContador::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_MAGNETISMO_ACTIVACION, DialogoContador::OnCActivacionActualizado )
	//EVT_CHOICE	 ( ID_MAGNETISMO_REPOSO_ELECTROIMAN, DialogoContador::OnCReposoActualizado )
//	EVT_CHOICE	 ( ID_MAGNETISMO_ACTIVACION_ELECTROIMAN, DialogoContador::OnCActivacionActualizado )
END_EVENT_TABLE()
