/*	Fichero dialogocontadorh
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Lunes 30-10-2006
*/


#ifndef _dialogocontador_h
#define _dialogocontador_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"
#include "contador.h"

#include "dialogo.h"


/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_CONTADOR=8030,
	ID_NUM_PULSOS,
	ID_VOLTAJE_ENTRADA_FLANCO_ALTO,
	ID_VOLTAJE_ENTRADA_FLANCO_BAJO ,
	ID_VOLTAJE_SALIDA_ACTIVACION ,
	ID_VOLTAJE_SALIDA_REPOSO
};

class DialogoContador : public Dialogo
{
	DECLARE_CLASS (DialogoContador)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoContador ();
		DialogoContador (wxWindow* ventanaPadre, 
							wxWindowID id=ID_DIALOGO_CONTADOR,
							const wxString& titulo= wxT ("Configurar contador"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		int	anchuraSpins;
		/*	Los controles. */
		wxBoxSizer*	contenedorCentral;
			
		wxBoxSizer *contenedorReposo;
		
		wxStaticText *lblReposo;
	    wxSpinCtrl *spnVSalidaReposo;
	    wxSpinCtrl *spnVSalidaActivacion;
	    wxSpinCtrl *spnVoltajeEntradaFlancoBajo;
	    wxSpinCtrl *spnVoltajeEntradaFlancoAlto;
	    wxSpinCtrl *spnNumPulsos;
	    
	    wxStaticText *lblActivacion;
	    wxStaticText *m_staticText5;
	    wxStaticText *lblDe;
	    wxStaticText *lblVolt;
	    wxStaticText *lblNumPulsos;
	    
	    wxStaticLine *lnSeparador2;
	    wxStaticLine *lnSeparador1;
	    
	    

		#define PROPORCION_ETIQUETAS 	3
		#define PROPORCION_SPINS		1
		
};

#endif
