#include "dialogomotor.h"
#include "dialogo.h"
#include "motor.h"

IMPLEMENT_CLASS (DialogoMotor, Dialogo)
DialogoMotor::DialogoMotor()
{
	Init();
}

DialogoMotor::DialogoMotor ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoMotor::Init()
{
	/*	Aqui se inicializan las variables */
}





void DialogoMotor::ConstruirControles()
{
contenedorCentral = new wxBoxSizer(wxVERTICAL);
  lnSeparador1 = new wxStaticLine(this, ID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL);
       
  contenedorCentral->Add(lnSeparador1, 0, wxALL|wxEXPAND, 5);
  wxBoxSizer *contenedorGiroHorario;
  contenedorGiroHorario = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeGiroHorario = new wxStaticText(this, ID_STATIC, wxT("Cuando se recibe un voltaje de"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorGiroHorario->Add(lblVoltajeGiroHorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVoltajeGiroHorario = new wxSpinCtrl(this, ID_VOLTAJE_GIRO_HORARIO, wxT("9"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 10, 0);
       
  contenedorGiroHorario->Add(spnVoltajeGiroHorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblGiroHorario = new wxStaticText(this, ID_STATIC, wxT("el motor"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorGiroHorario->Add(lblGiroHorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("gira a la izquierda"), wxT("gira a la derecha"), wxT("se detiene") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcGiroHorario = new wxChoice(this, ID_GIRO_HORARIO, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcGiroHorario->SetStringSelection ("gira a la izquierda");  
  contenedorGiroHorario->Add(chcGiroHorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorGiroHorario, 1, wxEXPAND, 5);
  wxBoxSizer *contenedorReposo;
  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeReposo = new wxStaticText(this, ID_STATIC, wxT("Cuando se recibe un voltaje de"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblVoltajeReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVoltajeReposo = new wxSpinCtrl(this, ID_VOLTAJE_GIRO_REPOSO, wxT("0"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 10, 0);
       
  contenedorReposo->Add(spnVoltajeReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblGiroReposo = new wxStaticText(this, ID_STATIC, wxT("el motor"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblGiroReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("gira a la izquierda"), wxT("gira a la derecha"), wxT("se detiene") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcGiroReposo = new wxChoice(this, ID_GIRO_REPOSO, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcGiroReposo->SetStringSelection (wxT("se detiene"));     
  contenedorReposo->Add(chcGiroReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
  wxBoxSizer *contenedorGiroAntihorario;
  contenedorGiroAntihorario = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeGiroAntihorario = new wxStaticText(this, ID_STATIC, wxT("Cuando se recibe un voltaje de"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorGiroAntihorario->Add(lblVoltajeGiroAntihorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVoltajeGiroAntihorario = new wxSpinCtrl(this, ID_VOLTAJE_GIRO_ANTIHORARIO, wxT("-9"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorGiroAntihorario->Add(spnVoltajeGiroAntihorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblGiroAntihorario = new wxStaticText(this, ID_STATIC, wxT("el motor"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorGiroAntihorario->Add(lblGiroAntihorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("gira a la izquierda"), wxT("gira a la derecha"), wxT("se detiene") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcGiroAntihorario = new wxChoice(this, ID_GIRO_ANTIHORARIO, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
	chcGiroAntihorario->SetStringSelection(wxT("gira a la derecha"));
  contenedorGiroAntihorario->Add(chcGiroAntihorario, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorGiroAntihorario, 1, wxEXPAND, 5);
  lnSeparador2 = new wxStaticLine(this, ID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL);
       
  contenedorCentral->Add(lnSeparador2, 0, wxALL|wxEXPAND, 5);
  wxBoxSizer *contenedorRPM;
  contenedorRPM = new wxBoxSizer(wxHORIZONTAL);
  lblGiroRPM = new wxStaticText(this, ID_STATIC, wxT("Velocidad (RPM)"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorRPM->Add(lblGiroRPM, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnRPM = new wxSpinCtrl(this, ID_RPM, wxT("100"), wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 0, 4000, 0);
       
  contenedorRPM->Add(spnRPM, 0, wxALL, 5);
  contenedorCentral->Add(contenedorRPM, 1, wxALIGN_CENTER_HORIZONTAL, 5);	
  
  ConstruirCuadroDeDialogo (contenedorCentral);
    
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoMotor::getPropiedades ( Elemento* elemento )
{
	Motor* m = (Motor*) elemento;
	TransferirDeNombreDeElementoAControl (elemento);
	TransferirDeVoltajeASpin ( spnVoltajeReposo,
			m->getVoltajeReposo() );
	TransferirDeVoltajeASpin ( spnVoltajeGiroHorario,
			m->getVoltajeGiroCW() );
	TransferirDeVoltajeASpin ( spnVoltajeGiroAntihorario,
			m->getVoltajeGiroCCW() );
	TransferirDeGiroAControl ( chcGiroReposo, m->getGiroReposo() 	);			
	TransferirDeGiroAControl ( chcGiroHorario, m->getGiroCW() 		);			
	TransferirDeGiroAControl ( chcGiroAntihorario, m->getGiroCCW() 	);			
}

void DialogoMotor::setPropiedades ( Elemento* elemento )
{
	Motor* m = (Motor*) elemento;
	TransferirDeControlANombreDeElemento (elemento);
	
	TransferirDeSpinAVoltaje ( spnVoltajeReposo,
			m->getVoltajeReposo() );
	TransferirDeSpinAVoltaje ( spnVoltajeGiroHorario,
			m->getVoltajeGiroCW() );
	TransferirDeSpinAVoltaje ( spnVoltajeGiroAntihorario,
			m->getVoltajeGiroCCW() );
	TransferirDeControlAGiro ( chcGiroReposo, m->getGiroReposo() 	);			
	TransferirDeControlAGiro ( chcGiroHorario, m->getGiroCW() 		);			
	TransferirDeControlAGiro ( chcGiroAntihorario, m->getGiroCCW() 	);			
	
}
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoMotor::OnCReposoActualizado ( wxCommandEvent& evento )
{

}

void DialogoMotor::OnCActivacionActualizado ( wxCommandEvent& evento )
{
}

BEGIN_EVENT_TABLE(DialogoMotor, wxDialog)
	//EVT_UPDATE_UI( ID_CONEXION_REPOSO, DialogoMotor::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_CONEXION_ACTIVACION, DialogoMotor::OnCActivacionActualizado )
	//EVT_CHOICE	 ( ID_CONEXION_REPOSO_PULSADOR, DialogoMotor::OnCReposoActualizado )
//	EVT_CHOICE	 ( ID_CONEXION_ACTIVACION_PULSADOR, DialogoMotor::OnCActivacionActualizado )
END_EVENT_TABLE()
