#include "dialogopulsador.h"
#include "dialogo.h"
#include "pulsador.h"

IMPLEMENT_CLASS (DialogoPulsador, Dialogo)
DialogoPulsador::DialogoPulsador()
{
	Init();
}

DialogoPulsador::DialogoPulsador ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoPulsador::Init()
{
	/*	Aqui se inicializan las variables */
}





void DialogoPulsador::ConstruirControles()
{
	
	/*	Se crean los contenedores */
	contenedorCentral	=	new wxBoxSizer	(wxVERTICAL);
	
    
    /*	Ahora se van construyendo los controles y aadiendo a sus
    	correspondientes contenedores de arriba a abajo*/	
	contenedorReposo		=	new wxBoxSizer	 (wxHORIZONTAL);
	contenedorActivacion	=	new wxBoxSizer	 (wxHORIZONTAL);
	
	
	
	/* Se construye la fila para cuando el pulsador esta activado*/
	lblConexionReposo = new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el pulsador est"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblConexionReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	
	wxString opciones1[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcConexionReposo = new wxChoice (this, ID_CONEXION_REPOSO_PULSADOR, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones1), 
		opciones1, ESTILO );
	chcConexionReposo->SetStringSelection ("desactivado");
	contenedorReposo->Add (chcConexionReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	lblVoltajeReposo = 	new wxStaticText (this, wxID_STATIC, 
		wxT("el pulsador emite un voltaje de"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblVoltajeReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnReposoPorDefecto="0";
	spnVReposo = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_PULSADOR, 
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorReposo->Add (spnVReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	/*	Fin de fila*/	
		
	/* Se crea ahora la fila con los controles para el voltaje de activacion*/
	
	lblConexionActiva = new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el pulsador est"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblConexionActiva,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString opciones2[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcConexionActivacion = new wxChoice 
		(this, ID_CONEXION_ACTIVACION_PULSADOR, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones2), 
		opciones2, ESTILO );
	chcConexionActivacion->SetStringSelection ("activado");
	contenedorActivacion->Add (chcConexionActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	lblVoltajeActivacion = 	new wxStaticText (this, wxID_STATIC, 
		wxT("el pulsador emite un voltaje de"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblVoltajeActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnActivacionPorDefecto="5";
	spnVActivacion = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_PULSADOR, 
		voltajeEnActivacionPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorActivacion->Add (spnVActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	
	contenedorCentral->Add (contenedorReposo,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	contenedorCentral->Add (contenedorActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	/*Fin de la fila central*/
	
	/*	Ahora que ya se tienen los controles centrales, se incrustan
		en el cuadro de dialogo basico estandar */
	
	ConstruirCuadroDeDialogo (contenedorCentral);
    
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoPulsador::getPropiedades ( Elemento* elemento )
{
	
//	Pulsador *pul = (Pulsador*) elemento;
	Pulsador *pul = dynamic_cast<Pulsador*> (elemento);
	TransferirDeNombreDeElementoAControl (pul);
	
	TransferirDeVoltajeASpin ( spnVReposo,
								pul->getVoltajeReposo() 		);
	TransferirDeVoltajeASpin ( spnVActivacion, 
								pul->getVoltajeActivacion () 	);
	
	TransferirDeConexionAChoice (chcConexionReposo, 
								pul->getConexionReposo() 	 	);
	TransferirDeConexionAChoice (chcConexionActivacion, 
								pul->getConexionActivacion() 	);
}

void DialogoPulsador::setPropiedades ( Elemento* elemento )
{
	Pulsador *pul = (Pulsador*) elemento;
	TransferirDeControlANombreDeElemento (pul);
	TransferirDeSpinAVoltaje ( spnVReposo    , pul->getVoltajeReposo() 		);
	TransferirDeSpinAVoltaje ( spnVActivacion, pul->getVoltajeActivacion () );
	TransferirDeChoiceAConexion (chcConexionReposo, 
								pul->getConexionReposo() 	 	);
	TransferirDeChoiceAConexion (chcConexionActivacion, 
								pul->getConexionActivacion() 	);
}
void		DialogoPulsador::setCNombre		( char* nombre )
{
	/*	Esto se hace asi porque el constructor de wxString controla
		la longitud del nombre y asi evitamos problemas en caso de
		nombre muy largos */
	DialogoPulsador::setNombre ( wxString(nombre) );
}

char*		DialogoPulsador::getCNombre		()
{
	return nombreElemento;
}

void		DialogoPulsador::setNombre		( wxString nombre )
{
	strcpy ( nombreElemento, nombre.c_str() );
}

wxString	DialogoPulsador::getNombre		()
{
	return wxString ( nombreElemento );
}


void		DialogoPulsador::setConexionReposo 		( bool cReposo )
{
	conexionReposo = cReposo;
}
bool		DialogoPulsador::getConexionReposo		()
{
	return conexionReposo;
}

void		DialogoPulsador::setConexionActivacion	( bool cActivacion )
{
	conexionActivacion = cActivacion;
}
bool		DialogoPulsador::getConexionActivacion	()
{
	return conexionActivacion;
}

void 		DialogoPulsador::setVoltajeReposo 		( int vReposo )
{
	voltajeReposo = vReposo;
}

int		DialogoPulsador::getVoltajeReposo		()
{
	return voltajeReposo;
}
		
void 		DialogoPulsador::setVoltajeActivacion	( int vActivacion )
{
	voltajeActivacion = vActivacion;
}

int		DialogoPulsador::getVoltajeActivacion	()
{
	return voltajeActivacion ;
}
		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoPulsador::OnCReposoActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcConexionReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcConexionActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcConexionActivacion->SetSelection (0);
	}
}

void DialogoPulsador::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcConexionActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0 )
	{
		//wxLogMessage ("Activado!");
		chcConexionReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcConexionReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoPulsador, wxDialog)
	//EVT_UPDATE_UI( ID_CONEXION_REPOSO, DialogoPulsador::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_CONEXION_ACTIVACION, DialogoPulsador::OnCActivacionActualizado )
	EVT_CHOICE	 ( ID_CONEXION_REPOSO_PULSADOR, DialogoPulsador::OnCReposoActualizado )
	EVT_CHOICE	 ( ID_CONEXION_ACTIVACION_PULSADOR, DialogoPulsador::OnCActivacionActualizado )
END_EVENT_TABLE()
