#include "dialogoreed.h"
#include "dialogo.h"
#include "reed.h"

IMPLEMENT_CLASS (DialogoReed, Dialogo)
DialogoReed::DialogoReed()
{
	Init();
}

DialogoReed::DialogoReed ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoReed::Init()
{
	/*	Aqui se inicializan las variables */
}





void DialogoReed::ConstruirControles()
{
	
	/*	Se crean los contenedores */
	contenedorCentral	=	new wxBoxSizer	(wxVERTICAL);
	
    
    /*	Ahora se van construyendo los controles y aadiendo a sus
    	correspondientes contenedores de arriba a abajo*/	
	contenedorReposo		=	new wxBoxSizer	 (wxHORIZONTAL);
	contenedorActivacion	=	new wxBoxSizer	 (wxHORIZONTAL);
	
	
	
	/* Se construye la fila para cuando el pulsador esta activado*/
	lblConexionReposo = new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el reed est"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblConexionReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	
	wxString opciones1[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcConexionReposo = new wxChoice (this, ID_CONEXION_REPOSO_REED, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones1), 
		opciones1, ESTILO );
	chcConexionReposo->SetStringSelection ("desactivado");
	contenedorReposo->Add (chcConexionReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	lblVoltajeReposo = 	new wxStaticText (this, wxID_STATIC, 
		wxT("el reed emite un voltaje de"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblVoltajeReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnReposoPorDefecto="0";
	spnVReposo = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_REED, 
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorReposo->Add (spnVReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	/*	Fin de fila*/	
		
	/* Se crea ahora la fila con los controles para el voltaje de activacion*/
	
	lblConexionActiva = new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el reed est"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblConexionActiva,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString opciones2[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcConexionActivacion = new wxChoice 
		(this, ID_CONEXION_ACTIVACION_REED, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones2), 
		opciones2, ESTILO );
	chcConexionActivacion->SetStringSelection ("activado");
	contenedorActivacion->Add (chcConexionActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	lblVoltajeActivacion = 	new wxStaticText (this, wxID_STATIC, 
		wxT("el reed emite un voltaje de"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblVoltajeActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnActivacionPorDefecto="5";
	spnVActivacion = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_REED, 
		voltajeEnActivacionPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorActivacion->Add (spnVActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	
	contenedorCentral->Add (contenedorReposo,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	contenedorCentral->Add (contenedorActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	/*Fin de la fila central*/
	
	/*	Ahora que ya se tienen los controles centrales, se incrustan
		en el cuadro de dialogo basico estandar */
	
	ConstruirCuadroDeDialogo (contenedorCentral);
    
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoReed::getPropiedades ( Elemento* elemento )
{
	Reed *reed = (Reed*) elemento;
	TransferirDeNombreDeElementoAControl (reed);
	TransferirDeVoltajeASpin ( spnVReposo,
								reed->getVoltajeSalidaReposo() 		);
	TransferirDeVoltajeASpin ( spnVActivacion, 
								reed->getVoltajeSalidaActivacion () 	);
	
	TransferirDeMagnetismoAChoice (chcConexionReposo, 
								reed->getMagnetismoReposo() 	 	);
	TransferirDeMagnetismoAChoice (chcConexionActivacion, 
								reed->getMagnetismoActivacion() 	);
}

void DialogoReed::setPropiedades ( Elemento* elemento )
{
	Reed *reed = (Reed*) elemento;
	TransferirDeControlANombreDeElemento (reed);
	TransferirDeSpinAVoltaje ( spnVReposo    , reed->getVoltajeSalidaReposo() 		);
	TransferirDeSpinAVoltaje ( spnVActivacion, reed->getVoltajeSalidaActivacion () );
	TransferirDeChoiceAMagnetismo (chcConexionReposo, 
								reed->getMagnetismoReposo() 	 	);
	TransferirDeChoiceAMagnetismo (chcConexionActivacion, 
								reed->getMagnetismoActivacion() 	);
}
		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoReed::OnCReposoActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcConexionReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcConexionActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcConexionActivacion->SetSelection (0);
	}
}

void DialogoReed::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcConexionActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0 )
	{
		//wxLogMessage ("Activado!");
		chcConexionReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcConexionReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoReed, wxDialog)
	//EVT_UPDATE_UI( ID_CONEXION_REPOSO, DialogoReed::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_CONEXION_ACTIVACION, DialogoReed::OnCActivacionActualizado )
	EVT_CHOICE	 ( ID_CONEXION_REPOSO_REED, DialogoReed::OnCReposoActualizado )
	EVT_CHOICE	 ( ID_CONEXION_ACTIVACION_REED, DialogoReed::OnCActivacionActualizado )
END_EVENT_TABLE()
