/*	Fichero dialogosistema.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un sistema
	
	Ultima actualizacion: Sabado 9-12-2006
*/


#ifndef _dialogosistema_h
#define _dialogosistema_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"
#include "constantes.h"
#include "dialogo.h"
#include "sistema.h"


/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_SISTEMA=9000
};

class DialogoSistema : public Dialogo
{
	DECLARE_CLASS (DialogoSistema)

	public: 
		DialogoSistema ();
		DialogoSistema ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_SISTEMA,
							const wxString& titulo= wxT ("Configurar reed"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();
		//bool Create (		wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_REED,
//							const wxString& caption= wxT ("Configurar pulsador"),
//							const wxPoint&  posicion=wxDefaultPosition,
//							const wxSize&   tam=wxDefaultSize,
//							long  			style=wxCAPTION | 
//													wxRESIZE_BORDER |
//													wxSYSTEM_MENU );	
		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
	
	private:
		
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];	
		wxBoxSizer*	contenedorCentral;
		
};

#endif
