#include "dialogozumbador.h"


#include "constantes.h"

IMPLEMENT_CLASS (DialogoZumbador, Dialogo)
DialogoZumbador::DialogoZumbador()
{
	Init();
}

DialogoZumbador::DialogoZumbador ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoZumbador::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoZumbador::ConstruirControles()
{
	
  
  contenedorCentral = new wxBoxSizer(wxVERTICAL);
  
  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeEntrada = new wxStaticText(this, ID_STATIC, wxT("Con voltaje de entrada"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblVoltajeEntrada, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVReposo = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO_ZUMBADOR, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorReposo->Add(spnVReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblZumbidoReposo = new wxStaticText(this, ID_STATIC, wxT("el zumbador est"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblZumbidoReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("activado"), wxT("desactivado") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcZumbidoReposo = new wxChoice(this, ID_ZUMBIDO_REPOSO_ZUMBADOR, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcZumbidoReposo->SetSelection(1);
         
  contenedorReposo->Add(chcZumbidoReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
  
  contenedorActivacion = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeActivacion = new wxStaticText(this, ID_STATIC, wxT("Con voltaje de entrada"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblVoltajeActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVActivacion = new wxSpinCtrl(this, ID_VOLTAJE_ACTIVACION_ZUMBADOR, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorActivacion->Add(spnVActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblZumbidoActivacion = new wxStaticText(this, ID_STATIC, wxT("el zumbador est"), wxDefaultPosition, wxSize(-1,-1), 0);
       
  contenedorActivacion->Add(lblZumbidoActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("activado"), wxT("desactivado") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcZumbidoActivacion = new wxChoice(this, ID_ZUMBIDO_ACTIVACION_ZUMBADOR, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcZumbidoActivacion->SetSelection(0);
       
  contenedorActivacion->Add(chcZumbidoActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorActivacion, 1, wxEXPAND, 5);
  
  contenedorFrecuencia = new wxBoxSizer(wxHORIZONTAL);
  lblFrecuencia = new wxStaticText(this, ID_STATIC, wxT("Frecuencia de zumbido"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorFrecuencia->Add(lblFrecuencia, 0, wxALL|wxALIGN_CENTER_VERTICAL|wxALIGN_CENTER_HORIZONTAL, 5);
  spnFrecuencia = new wxSpinCtrl(this, ID_FRECUENCIA_ZUMBADOR, wxT("0"), wxDefaultPosition, wxSize(75,-1), wxSP_ARROW_KEYS, 0, 5000, 0);
       
  contenedorFrecuencia->Add(spnFrecuencia, 0, wxALL, 5);
  contenedorCentral->Add(contenedorFrecuencia, 0, wxALIGN_CENTER_HORIZONTAL, 5);
	  
  ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/


/*	Precaucion: Hack un poco peligroso.
	En estos metodos se asume algo que el diseo original del zumbador
	no tenia. Un zumbador tiene una frecuencia en reposo (que normalmente
	es 0) y una frecuencia cuando se activa (normalmente mayor que 0). Este
	dilogo trabaja dando por supuesto estas cosas pero el diseo conceptual
	no encajaria muy bien si tal vez el usuario quisiera crear un zumbador
	que zumbara en reposo y se callara al activarse o si quisiera un zumbador
	que sonara siempre pero a frecuencias distintas en funcion de si recibe
	un voltaje u otro. 
	
	Todo esto funciona sin problemas pero si se desean estas caracteristicas
	especiales habra que modificar el dialogo y aadir controles para
	estas frecuencias adicionales, as como modificar este codigo.
	
	Si te ha tocado pelearte con esto, ten paciencia y leete bien la memoria
	para comprender mejor el diseo. He procurado usar patrones y tcnicas
	de implementacin que te faciliten la modificacin y la ampliacin del
	diseo as como incorporar fcilmente cosas nuevas a la implementacin pero
	lete bien la memoria, insisto.
*/
void DialogoZumbador::getPropiedades ( Elemento* elemento )
{
	Zumbador*  zumzum= (Zumbador*) elemento;
	
	TransferirDeNombreDeElementoAControl (elemento);
	
	TransferirDeVoltajeASpin 	( spnVReposo, 		zumzum->getVoltajeReposo() 		);
	TransferirDeVoltajeASpin 	( spnVActivacion, 	zumzum->getVoltajeActivacion() 	);
	TransferirDeFrecuenciaASpin ( spnFrecuencia,	zumzum->getFrecuencia()			);
	
}

void DialogoZumbador::setPropiedades ( Elemento* elemento )
{
	Zumbador*  zumzum= (Zumbador*) elemento;
	
	TransferirDeControlANombreDeElemento (elemento);
	
	TransferirDeSpinAVoltaje 	( spnVReposo, 		zumzum->getVoltajeReposo() 		);
	TransferirDeSpinAVoltaje 	( spnVActivacion, 	zumzum->getVoltajeActivacion() 	);
	TransferirDeSpinAFrecuencia ( spnFrecuencia,	zumzum->getFrecuencia()			);
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/

/*************************************************/
/*	Gestion de eventos							 */
/*************************************************/

void DialogoZumbador::OnCReposoActualizado ( wxCommandEvent& evento )
{

	wxChoice* cActivacion = chcZumbidoActivacion;
	wxChoice* cReposo = chcZumbidoReposo;

	wxString cadena = cReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		cActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		cActivacion->SetSelection (0);
	}
}

void DialogoZumbador::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxChoice* cActivacion = chcZumbidoActivacion;
	wxChoice* cReposo = chcZumbidoReposo;

	wxString cadena = cActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0 )
	{
		//wxLogMessage ("Activado!");
		cReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		cReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoZumbador, wxDialog)

	EVT_CHOICE	 ( ID_ZUMBIDO_REPOSO_ZUMBADOR, DialogoZumbador::OnCReposoActualizado )
	EVT_CHOICE	 ( ID_ZUMBIDO_ACTIVACION_ZUMBADOR, DialogoZumbador::OnCActivacionActualizado )
END_EVENT_TABLE()
