#include "electroimanvisual.h"

ElectroimanVisual::ElectroimanVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Electroiman.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/ElectroimanInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/ElectroimanActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		SetNombre ("Electroiman");
		elementoEnvuelto = new Electroiman(	new Voltaje(0.0),
										new Voltaje(5.0),
										new Magnetismo (false),
										new Magnetismo (true)
									);
		estado_actual = INACTIVO;
		bitmapEnPantalla = bitmapElementoInactivo;
		
		Electroiman* aux = dynamic_cast<Electroiman*> (elementoEnvuelto);
		senalReposo 	= aux->getVoltajeEntradaReposo();
		senalActivacion	= aux->getVoltajeEntradaActivacion();

		//senalReposo 	= new Voltaje (0.0);
//		senalActivacion	= new Voltaje (5.0);
}	

void ElectroimanVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---ElectroimanVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	Electroiman* electroiman = dynamic_cast<Electroiman*> (e);
	senalReposo 	= electroiman->getVoltajeEntradaReposo();
	senalActivacion = electroiman->getVoltajeEntradaActivacion();
	SetNombre (e->getNombreElemento());
	
}
Dialogo* ElectroimanVisual::FabricarDialogo()
{
	return new DialogoElectroiman();
}


