/*	Todos estos metodos estn heredados de la clase Elemento.
	Se han puesto separados para remarcar que lo unico que
	hacen es redirigir el codigo hacia el elemento envuelto. */

#include "elementovisual.h"
	
int ElementoVisual::anadirSuscriptor (Elemento* e,int pos_entrada,int pos_salida)
{
	assert (e!=NULL);
	assert (pos_entrada>=0);
	assert (pos_salida>=0);
	wxLogMessage ("----ElementoVisual::anadirSuscriptor---");
	wxLogMessage ("Parametros:Elemento receptor e no es NULL (nombre %s), pos_entrada=%i, pos_salida=%i",
		e->getNombreElemento(),pos_entrada, pos_salida);
	int codigo = Conectar (e, pos_entrada, pos_salida);
	return codigo;
}


void ElementoVisual::manejarEntrada (Senal* senal, int posicion)
{
	bool son_senales_iguales;
	wxLogMessage ("Llega una entrada %s al elemento %s", senal->toString(), 
		nombreElemento);
	assert (senal!=NULL);
	assert (senalReposo!=NULL);
	assert (senalActivacion!=NULL);
	
	/*	Si el pulsador est inactivo ... */
	if (estado_actual == INACTIVO)
	{	
		/*... y la seal pasada tiene el valor de la seal
			de activacion...*/
		son_senales_iguales = iguales (senal, senalActivacion);
		if ( son_senales_iguales )
		{
			/*...se cambia el estado */
			bitmapEnPantalla = bitmapElementoActivo;
			wxLogMessage (nombreDelElementoVisual +" activado");
			estado_actual=ACTIVO;
		}
	}
	else if (estado_actual == ACTIVO)
	{
		son_senales_iguales = iguales (senal, senalReposo);
		if ( son_senales_iguales )
		{
			bitmapEnPantalla = bitmapElementoInactivo;
			wxLogMessage (nombreDelElementoVisual +" desactivado");
			estado_actual=INACTIVO;
		}
	}
}
int ElementoVisual::setEntrada(Senal* entrada, int posicion)
{
	assert (entrada!=NULL);
	assert (posicion>=0);
	this->manejarEntrada (entrada, posicion);
	/*	Una vez recibida una nueva entrada se repinta la ventana si la hay
		para que as se repinte el nuevo icono si el elemento se ha
		activado */
	if (paginaPadre!=NULL)
	{
		wxPaintEvent evento_de_repintado;
		wxPostEvent (paginaPadre, evento_de_repintado);
	}
	else {
		wxMessageBox ("Cuidado: El elemento %s no tiene ventana padre", 
			nombreElemento);
	}
	
	int codigo = elementoEnvuelto->setEntrada(entrada, posicion);
	return codigo;
}


int ElementoVisual::getTipoEntrada (int posicion)
{
	
	wxLogMessage ("----ElementoVisual::getTipoEntrada (elemento %s)----",
		elementoEnvuelto->getNombreElemento());
	wxLogMessage ("Parametros: posicion=%i", posicion);
	assert (elementoEnvuelto!=NULL);
	int tipo=elementoEnvuelto->getTipoEntrada(posicion);
	wxLogMessage ("El tipo de la entrada es %i", tipo);
	/* Examinar el fichero senal.h El tipo de senal devuelto
		debe estar entre 0 y 6. Si se aaden ms tipos de
		seal habr que modificar esto */
	assert (tipo>=0);
	assert (tipo<=6);
	return tipo;
}

int ElementoVisual::getTipoSalida (int posicion)
{
	assert (posicion>=0);
	wxLogMessage ("---ElementoVisual::getTipoSalida---");
	wxLogMessage ("El elemento al que pertenece esta ejecucion se llama %s",
		elementoEnvuelto->getNombreElemento());
		
	int tipo=elementoEnvuelto->getTipoSalida(posicion);
	assert (tipo>=0);
	return tipo;
}


int ElementoVisual::getTotalEntradas ()
{
	assert (elementoEnvuelto!=NULL);
	int totalEntradas = elementoEnvuelto->getTotalEntradas();
	assert (totalEntradas>=0);
	assert (totalEntradas<10);
	return totalEntradas;
}

int ElementoVisual::getTotalSalidas ()
{
	assert (elementoEnvuelto!=NULL);
	int totalSalidas = elementoEnvuelto->getTotalSalidas();
	assert (totalSalidas>=0);
	assert (totalSalidas<10);
	return totalSalidas;
}

int ElementoVisual::getTotalSuscripciones ()
{
	return elementoEnvuelto->getTotalSuscripciones();
}


Suscripcion** ElementoVisual::getSuscripciones()
{
	return elementoEnvuelto->getSuscripciones();
}

void ElementoVisual::setX(int x)
{
	this->x=x;
	elementoEnvuelto->setX(x);
}

void ElementoVisual::setY(int y)
{
	this->y=y;
	elementoEnvuelto->setY(y);
}

/*	Permite conocer el nombre de las entradas y salidas, as
		como las posiciones que ocupan */
map<string,int> ElementoVisual::getNombreEntradas	()
{
	assert (elementoEnvuelto!=NULL);
	return elementoEnvuelto->getNombreEntradas();
}
map<string,int> ElementoVisual::getNombreSalidas	()
{
	assert (elementoEnvuelto!=NULL);
	return elementoEnvuelto->getNombreSalidas();
}

void ElementoVisual::construir (DOMElement* elementoXML)
{
	
	//this->setElementoEnvuelto (elementoConstruido);
}
