#include "reedvisual.h"

ReedVisual::ReedVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Reed.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		wxString ficheroIconoInactivo ("iconos/ReedInactivo.xpm");
		bitmapElementoInactivo.LoadFile(ficheroIconoInactivo, TIPO_ICONOS);
		
		wxString ficheroIconoActivo ("iconos/ReedActivo.xpm");
		bitmapElementoActivo.LoadFile(ficheroIconoActivo, TIPO_ICONOS);
		
		Voltaje* voltajeSalidaReposo		=	new Voltaje(0.0);
		Voltaje* voltajeSalidaActivacion	=	new Voltaje(5.0);

		Magnetismo* magReposo			= 	new Magnetismo (false);
		Magnetismo* magActivacion		=	new Magnetismo (true);
		
		SetNombre ("Reed");
		elementoEnvuelto = new Reed (magReposo, 	voltajeSalidaReposo,
									magActivacion, 	voltajeSalidaActivacion);
		estado_actual = INACTIVO;
		bitmapEnPantalla = bitmapElementoInactivo;
		
		/* Se toma nota de los valores necesarios para que el elemento
			pase a estado de reposo o de activacion */
		Reed* aux = dynamic_cast<Reed*> (elementoEnvuelto);
		senalReposo 	= aux->getMagnetismoReposo();
		senalActivacion	= aux->getMagnetismoActivacion();									
}

void ReedVisual::setElementoEnvuelto (Elemento* e)
{
	wxLogMessage ("---ReedVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (e);
	Reed* reed = dynamic_cast<Reed*> (e);
	senalReposo 	= reed->getMagnetismoReposo();
	senalActivacion = reed->getMagnetismoActivacion();
	SetNombre (e->getNombreElemento());
	
}

Dialogo* ReedVisual::FabricarDialogo()
{
	return new DialogoReed();
}


