#ifndef _temporizadorvisual_h

#define _temporizadorvisual_h

#include "elementovisual.h"
#include "../dialogos/dialogotemporizador.h"


class TemporizadorVisual : public ElementoVisual, public wxTimer
{
	public:
		TemporizadorVisual ();
		virtual void setElementoEnvuelto (Elemento* e);
		virtual Dialogo* FabricarDialogo();
		
		/*	Se proporciona un manejador de entradas especial, ya que
			el temporizador tiene un comportamiento diferente */
		virtual void manejarEntrada (Senal* entrada, int posicion);
		
		/*	Lo mismo para este mtodo, se reimplementa por ser algo
			diferente de lo proporcionado para un elemento visual */
		virtual int setEntrada (Senal* entrada, int posicion=POS_ENTRADA);
		
		virtual void ConmutarEntrada();
		/*	Este mtodo se hereda de wxTimer. Es la forma mas comoda
			de pedir al temporizador que actualice su cuenta */
		void Notify();
};
#endif

