#ifndef _codificador_
#define _codificador_

#include <iostream>


/*	Esta clase es solo una definicin de ayuda a la macro que hay abajo
	Se utiliza en los mtodos XML para simplificar el paso de cadenas 
	desde tipos char* a XMLCh*.
	
	No se puede incluir por las buenas en cualquier fichero, ya que
	no contiene las cabeceras XML de Xerces. Se asume que este fichero
	codificador.h es incluido despues de dichas cabeceras, que no se
	han puesto aqui para mejorar la compilacin */
class XStr
{
public :
    // -----------------------------------------------------------------------
    //  Constructores and Destructores
    // -----------------------------------------------------------------------
    XStr(const char* const cadena)
    {
        // Pasamos de char* a XMLCh*
        cadenaUnicode = XMLString::transcode(cadena);
    }
	XStr(int num)
    {
		char cadena[10];
		sprintf (cadena, "%i", num);

        cadenaUnicode = XMLString::transcode(cadena);
    }
    ~XStr()
    {
        XMLString::release(&cadenaUnicode);
    }



    const XMLCh* formatoUnicode() const
    {
        return cadenaUnicode;
    }

private :
    // -----------------------------------------------------------------------
    //
    //  cadenaUnicode
    //      Es la cadena en formato Unicode
    // -----------------------------------------------------------------------
    XMLCh*   cadenaUnicode;
};
/* 	Con esta macro podemos codificar de una forma tan sencilla
	como usar C ("etiqueta"). Extraido de los ejemplos de Xerces */
#define C(str) XStr(str).formatoUnicode()

#endif
