#include "conector.h"
#include "constantes.h"

Conector::Conector()
{
	strcpy (nombreElemento, "Conector");
	esta_libre=true;
	setX(500);
	setY(500);
}
Conector::~Conector()
{
	printf ("Destruyendo conector");
	eliminarSuscripcionesAElemento(this);
	printf ("Conector destruido!\n");
}
int Conector::setEntrada (Senal* s, int entrada)
{
//	printf ("//Se intenta poner una senal %s en la entrada %i de un con de %s\n",
//		s->toString(), entrada, nombreElemento);
	entradas[POS_ENTRADA]=s;
	salidas[POS_SALIDA]=s;
	//printf ("Se activa el conector con una seal %s\n", s->toString() );
//	return (Elemento::setEntrada(s, entrada));	
	/*	El conector propaga su unica salida y no la envia a ninguna
		posicion concreta*/
	return (Elemento::setEntrada(s, entrada));	
}

void Conector::actualizar()
{
	notificar();
}
bool Conector::tienePorSuscriptor (Elemento* e)
{
	for (int i=0; i<totalSuscripciones; i++)
	{
		if (suscripciones[i]->getElementoSuscriptor()==e)
		{
			return true;
		}
	}
	return false;
}

bool Conector::estaLibre()
{
	return esta_libre;
}

bool Conector::esVisible()
{
	/*	 Los conectores no son visibles */
	return false;
}
void Conector::marcarComoUsado()
{
	esta_libre=false;
}
void Conector::liberar()
{
	if (totalSuscripciones>1)
	{
		printf ("Error, un conector solo puede tener una suscripcion");
		exit (-1);
	}
	if (totalSuscripciones==1)
	{
		/*	Tambien se notifica al elemento que deje
			de tomar nota de que somos avisadores suyos */
		Elemento* suscriptor = suscripciones[0]->getElementoSuscriptor();
		suscriptor->eliminarAvisador(this);
		delete suscripciones[0];
		suscripciones[0]=NULL;
		totalSuscripciones=0;
	}
	esta_libre=true;
}
int Conector::eliminarSuscripcionesAElemento (Elemento *e)
{
	bool elemento_es_nulo = (e==NULL);
	assert (!elemento_es_nulo);
	/*	Es un poco complicado de entender al principio pero es
		fcil. 
		Esta funcion ha sido diseada para que sea llamada por
		suscriptores nuestros, es decir, elementos a los cuales
		avisamos de cambios en la entrada del conector. Cuando alguno
		de los suscriptores pide que un conector deje de enviarle
		avisos, los conectores DEBEN propagar una notificacion
		de eliminacion para que elementos externos dejen de avisar
		al conector. Si no se hiciera as, los elementos externos
		seguiran enviando avisos al conector. No es que eso
		estuviera muy  mal pero parece poco recomendable */
		
		notificarEliminacion();
		int codigo = Elemento::eliminarSuscripcionesAElemento(this);
		return codigo;
		
}
