#ifndef _correspondencia_h
#define _correspondencia_h

/* 	Aqui no hace falta el include. Ademas, esto acelera
	la compilacion */
class Elemento;
class Conector;

/*	Esto se debe hacer mucho antes durante el desarrollo: 
	aislar los tipos, aunque nunca es tarde. Si ms
	adelante se desea cambiar el int por un unsigned o long
	es relativamente sencillo */
typedef int t_posicion;


/*	Esto es un poco como una minitabla de una bbdd. Puede parecer
	poco elegante pero permite reducir muchsimo tanto la
	complejidad como el tamao de la clase Sistema */
class Correspondencia
{
	
	public:
		Correspondencia();
		Correspondencia(Elemento* e, 
			t_posicion pos_elemento, t_posicion pos_sistema,
			Conector* conector);
		Elemento* 	getElemento();
		t_posicion 	getPosElemento();
		t_posicion 	getPosSistema();
		Conector*	getConector();
		bool 		contiene(Elemento* e);
	private:
		Elemento* elemento;
		t_posicion pos_en_el_elemento;
		t_posicion pos_en_el_sistema;
		/*	Este el conector de la clase sistema que conecta
			con una cierta entrada o salida del elemento */
		Conector* conector;
		
		/*	No es imprescindible pero ayuda en la depuracion */
		char nombre[100];
};
#endif
