#include "fabricaelementos.h"

FabricaDeElementos::FabricaDeElementos()
{
		/* 	Se establece una correspondencia entre los nombres
		de los elementos y las constantes que los representan*/
	
	
	codigoDeElemento["pulsador"]	=PULSADOR;
	codigoDeElemento["electroiman"]	=ELECTROIMAN;
	codigoDeElemento["biestable"]	=BIESTABLE;
	codigoDeElemento["reed"]		=REED;
	codigoDeElemento["lampara"]		=LAMPARA;
	codigoDeElemento["temporizador"]=TEMPORIZADOR;
	codigoDeElemento["rele"]		=RELE;
	codigoDeElemento["biestable"]	=BIESTABLE;
	codigoDeElemento["zumbador"]	=ZUMBADOR;
	codigoDeElemento["fotosensor"]	=FOTOSENSOR;
	codigoDeElemento["motor"]		=MOTOR;
	codigoDeElemento["sistema"]		=SISTEMA;
	codigoDeElemento["contador"]	=CONTADOR;
	
}

Elemento* FabricaDeElementos::CrearElemento(int tipoDeElemento)
{
	Elemento* elementoADevolver=NULL;
	switch (tipoDeElemento)
	{
		case PULSADOR:
			{
				elementoADevolver = new Pulsador();
				break;
			} /* Fin del case Pulsador */
		case ELECTROIMAN:
			{
				elementoADevolver = new Electroiman();
				break;
			} /* Fin del case Electroiman */
		case BIESTABLE:
			{
				elementoADevolver = new Biestable();
				break;
			} /* Fin del case Biestable */
		case REED:
			{
				elementoADevolver = new Reed();
				break;
			} /* Fin del case Zumbador */
		case TEMPORIZADOR:
			{
				elementoADevolver = new Temporizador();
				/* 	Cuidado, quiz al crear el temporizador y no poner
					la ventana padre o no aadirlo al vector temporizadores
					el temporizador no funcione correctamente */
				break;
			} /* Fin del case Temporizador */
		
		case ZUMBADOR:
			{
				elementoADevolver = new Zumbador();
				break;
			} /* Fin del case Zumbador */
			
		case RELE:
			{
				elementoADevolver = new Rele();
				break;
			} /* Fin del case Rele */


		case CONTADOR:
			{
				elementoADevolver = new Contador();
				break;
			} /* Fin del case contador */

		case LAMPARA:
			{
				elementoADevolver = new Lampara();
				break;
			}

		case FOTOSENSOR:
			{
				elementoADevolver = new FotoSensor();
				break;
			}
		case MOTOR:
			{
				elementoADevolver = new Motor();
				break;
			}

//		case SISTEMA:
//			{
//				elementoADevolver = new Sistema();
//				break;
//			}
		default:
			{
				elementoADevolver=NULL;
				break;
			}
	} /*Fin del switch */
	assert (elementoADevolver!=NULL);
	return elementoADevolver;

}

Elemento* FabricaDeElementos::CrearElemento(char* nombre)
{
	string nombrecpp(nombre);
	int codigo = codigoDeElemento[nombre];
	
	Elemento* elementoADevolver = CrearElemento (codigo);
	assert (elementoADevolver!=NULL);
	
	return elementoADevolver;
}
