#include "motor.h"
#include "constantes.h"
#include <iostream>
using namespace std;
Motor::Motor ()
{
	this->voltajeReposo	=	NULL;
	this->giroReposo	=	NULL;
	this->voltajeGiroCW	=	NULL;
	this->giroCW		=	NULL;
	this->voltajeGiroCCW=	NULL;
	this->giroCCW		=	NULL;
	this->rpm			=	0;
	
	entradas[POS_ENTRADA]=NULL;
	salidas [POS_SALIDA] =NULL;
	
}
Motor::Motor (Voltaje* voltReposo,	Giro* giroReposo, 
			  Voltaje* voltGiroCW,	Giro* giroCW,
			  Voltaje* voltGiroCCW,Giro* giroCCW, unsigned int revoluciones)
{
	this->voltajeReposo	=	voltReposo;
	this->giroReposo	=	giroReposo;
	this->voltajeGiroCW	=	voltGiroCW;
	this->giroCW		=	giroCW;
	this->voltajeGiroCCW=	voltGiroCCW;
	this->giroCCW		=	giroCCW;
	this->rpm			=	revoluciones;
	
	entradas[POS_ENTRADA]=voltReposo;
	salidas [POS_SALIDA] =giroReposo;
}

Voltaje* Motor::getVoltajeReposo()
{
	return voltajeReposo;
}

Voltaje* Motor::getVoltajeGiroCW()
{
	return voltajeGiroCW;
}

Voltaje* Motor::getVoltajeGiroCCW()
{
	return voltajeGiroCCW;
}

Giro* Motor::getGiroReposo()
{
	return giroReposo;
}

Giro* Motor::getGiroCW()
{
	return giroCW;
}

Giro* Motor::getGiroCCW()
{
	return giroCCW;
}
		
unsigned int Motor::getRPM()
{
	return rpm;
}
void Motor::setRPM (unsigned int RPM)
{
	this->rpm=RPM;
}

int Motor::setEntrada(Senal* entrada, int posicion)
{
	Voltaje* voltEntrada=(Voltaje*)entrada;
	
	if (voltEntrada->getValor()==voltajeReposo->getValor())
	{
		#ifdef DEBUG_MOTOR
		printf ("Motor parado\n");
		#endif
		entradas[POS_ENTRADA]=voltEntrada;
		salidas [POS_SALIDA] =giroReposo;
		return (Elemento::setEntrada(entrada,posicion));
	}
	
	if (voltEntrada->getValor()==voltajeGiroCCW->getValor())
	{
		#ifdef DEBUG_MOTOR
		printf ("Motor gira CCW\n");
		#endif
		entradas[POS_ENTRADA]=voltajeGiroCW;
		salidas [POS_SALIDA] =giroCCW;
		return (Elemento::setEntrada(entrada,posicion));
	}
	
	if (voltEntrada->getValor()==voltajeGiroCW->getValor())
	{
		#ifdef DEBUG_MOTOR
		printf ("Motor gira CW\n");
		#endif
		entradas[POS_ENTRADA]=voltajeGiroCW;
		salidas [POS_SALIDA] =giroCW;
		return (Elemento::setEntrada(entrada,posicion));
	}
	
	/*	Entrada no contemplada*/
	entradas[POS_ENTRADA]=voltEntrada;
	return (Elemento::setEntrada(entrada,posicion));
}

NodoXML Motor::getXML ( DOMImplementation *impl )
{
	//etqElemento se hereda por parte de XMLSerializable	
	//etqElemento = XMLString::transcode ( "motor" );
	
	DOMDocument* doc = impl->createDocument ();
	cout << "Creando documento base XML para motor\n";
	doc = getDocumentoXMLBase ( doc, "motor", nombreElemento, x, y );
	/*	Ahora aadimos a doc los elementos XML para indicar las distintas
		caractersticas. No se debe alterar el orden de creacin de elementos
		ya que el esquema exige dicho orden */
	cout <<"Entrando en entradagiro1" <<endl;
	anadirElementoXML (doc, "entradagiro1",	
								getVoltajeGiroCW() 			);
	cout <<"Entrando en salidagiro1" <<endl;
	anadirElementoXML (doc, "salidagiro1",		
								getGiroCW() 				);
	cout <<"Entrando en eg2" <<endl;
	anadirElementoXML (doc, "entradagiro2",	
								getVoltajeGiroCCW() 		);
	cout <<"Entrando en sg2" <<endl;
	anadirElementoXML (doc, "salidagiro2",		
								getGiroCCW() 				);
	cout <<"Entrando en er" <<endl;
	anadirElementoXML (doc, "entradareposo", 		
								getVoltajeReposo() 			);
	cout <<"Entrando en sr" <<endl;
	anadirElementoXML (doc, "salidareposo", 		
								getGiroReposo()				);
	cout << "XML motor:Activacion creada\n";
	DOMDocumentFragment* fragmento = doc->createDocumentFragment ();
	fragmento->appendChild ( doc->getDocumentElement() );
	cout << "Final de Motor::getXML";
	return fragmento;
}



void Motor::construir (DOMElement* nodo)
{
	obtenerDatosComunes (nodo);

	/* Obtenemos los valores de los distintos nodos */
	voltajeReposo		= (Voltaje*) getSenal (VOLTAJE, "entradareposo", nodo);
	voltajeGiroCW		= (Voltaje*) getSenal (VOLTAJE, "entradagiro1",  nodo);
	voltajeGiroCCW		= (Voltaje*) getSenal (VOLTAJE, "entradagiro2",  nodo);
	
	giroReposo			= (Giro*) 	 getSenal (GIRO, "salidareposo", nodo);
	giroCW				= (Giro*) 	 getSenal (GIRO, "salidagiro1",  nodo);
	giroCCW				= (Giro*) 	 getSenal (GIRO, "salidagiro2",  nodo);
	
	entradas[POS_ENTRADA]	=voltajeReposo;
	salidas[POS_SALIDA]		=giroReposo;
}
