#include "elemento.h"

#ifndef _pulsador_
#define _pulsador_

class Pulsador: public Elemento
{
	public:
		/* 	Cuando se conecta de la forma c1, se devuelve el voltaje v1
			y cuando se conecta de la forma c2, se devuelve el voltaje v2*/
		Pulsador	(	Conexion* c1=NULL, Voltaje *v1=NULL,
					 	Conexion* c2=NULL, Voltaje* v2=NULL );
		~Pulsador();
		Conexion*	getConexionReposo		();
		Conexion*	getConexionActivacion	();
		Voltaje*	getVoltajeReposo		();
		Voltaje*	getVoltajeActivacion	();
		void		setConexionReposo		(Conexion* c);
		void		setConexionActivacion	(Conexion* c);
		void		setVoltajeReposo		(Voltaje* v);
		void		setVoltajeActivacion	(Voltaje* v);
		int			setEntrada (Senal* s, int posicion=POS_ENTRADA);
		
		//Metodos heredados de elemento (clase abstracta)
		virtual NodoXML getXML ( DOMImplementation* impl );
		virtual void construir 		(DOMElement*);

	protected:
		Conexion* c1;
		Conexion* c2;
		Voltaje*  v1;
		Voltaje*  v2;
};

#endif
