#ifndef _suscripcion_
#define _suscripcion_


#include "xmlserializable.h"
class Elemento;
/*	Una suscripcin queda determinada por el elemento que hace la suscripcion
	el elemento al que se suscribe y que le avisa, la posicion de la salida del
	avisador que est escuchando y la entrada del suscriptor a la que va 
	conectada
	
	Se ha dejado como clase y no como estructura en previsin 
	de futuros cambios
	
	El tomar nota del elemento avisador no es muy necesario ya que cada
	elemento que avise se conoce a si mismo y solo necesitaria conocer
	a los elementos suscritos a l pero en previsin de ampliaciones
	se ha decidido dejar la estructura asi*/
	
	
class Suscripcion
{
	public:
		/*	Metodos getter */
		Elemento* getElementoSuscriptor   ();
		Elemento* getElementoAvisador     ();
		int		  getPosEntradaSuscriptor ();
		int		  getPosSalidaAvisador	  ();
		
		/*	Metodos setter */
		int setElementoSuscriptor (Elemento* e);
		
		int  setElementoAvisador (Elemento *e);
		
		int setEntradaSuscriptor (int entrada);
		
		int setSalidaAvisador (int salida);
		void construir (DOMElement*);
	private:
		Elemento* elementoSuscriptor;
		Elemento* elementoAvisador;
		int entradaSuscriptor;
		int salidaAvisador;
		/* 	El nombre puede ser muy largo, pero ayuda mucho*/
		bool suscripcion_con_un_elemento_dentro_de_un_sistema;
		const char nombre[MAX_LONG_NOMBRE_ELEMENTO];
};



#endif
