#include "unit++.h"
#include "biestable.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLBiestable : public suite
	{
		void PruebaValoresBiestable()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un nico pulsador*/
			ficheroCorrecto	=	p->esValido ("xml\\biestable.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XMLBiestable obtenido" << endl;
				/* 	En este punto deberia haber un biestable dentro del
					sistema. El biestable de este fichero se llama 
					"B1" (no modificar los ficheros de test del
					directorio xml) */
				Biestable* b=(Biestable*)
					sistemaParseado->getRefElementoPorNombre("B1");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores a mano...*/	
				Voltaje*  v1=new Voltaje  (0.0);
				Voltaje*  v2=new Voltaje  (9.0);
				
				Voltaje  *vEntradaReposoR;
				Voltaje  *vEntradaActivacionR;
				Voltaje  *vEntradaReposoS;
				Voltaje  *vEntradaActivacionS;
				Voltaje  *vSalidaReposoQ;
				Voltaje  *vSalidaActivacionQ;
				Voltaje  *vSalidaReposoQneg;
				Voltaje  *vSalidaActivacionQneg;
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vEntradaActivacionR = b->getActivacionR();
				assert_eq ("(XML)Activacion R en biestable", 
					vEntradaActivacionR->getValor(), v2->getValor() );
					
				vEntradaActivacionS = b->getActivacionS();
				assert_eq ("(XML)Activacion S en biestable", 
					vEntradaActivacionS->getValor(), v2->getValor() );
					
				vEntradaActivacionR = b->getEntradaActivacionR();
				assert_eq ("(XML)Activacion R en biestable", 
					vEntradaActivacionR->getValor(), v2->getValor() );
					
				vEntradaActivacionS = b->getEntradaActivacionS();
				assert_eq ("(XML)Activacion S en biestable", 
					vEntradaActivacionS->getValor(), v2->getValor() );
				
				vEntradaReposoS = b->getEntradaReposoS();
				assert_eq ("(XML)Reposo S en biestable", 
					vEntradaReposoS->getValor(), v1->getValor() );

				vEntradaReposoR = b->getEntradaReposoR();
				assert_eq ("(XML)Reposo R en biestable", 
					vEntradaReposoR->getValor(), v1->getValor() );
					
					
				////Comprobacion de las salidas
				vSalidaActivacionQ = b->getSalidaActivacionQ();
				assert_eq ("(XML)Activacion R en biestable", 
					vSalidaActivacionQ->getValor(), v2->getValor() );
					
				vSalidaActivacionQ = b->getSalidaActivacionQ();
				assert_eq ("(XML)Activacion S en biestable", 
					vSalidaActivacionQ->getValor(), v2->getValor() );
				
				vSalidaReposoQneg = b->getSalidaReposoQneg();
				assert_eq ("(XML)Reposo S en biestable", 
					vSalidaReposoQneg->getValor(), v1->getValor() );

				vSalidaReposoQneg = b->getSalidaReposoQneg();
				assert_eq ("(XML)Reposo R en biestable", 
					vSalidaReposoQneg->getValor(), v1->getValor() );
				////Fin de comprobacion de las salidas
				p->escribir (b, "xml-resultadoTest-xmlbiestable.xml");
				p->escribir (sistemaParseado, 
					"xml-resultadoTest-xmlSistemaBiestable.xml");
				delete p;	
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLBiestable() : suite ("Prueba del XML del biestable")
			{
				add ("PruebaXMLBiestable", testcase (this,
					"PruebaXMLBiestable", 
					&PruebaXMLBiestable::PruebaValoresBiestable) );
				
				suite::main().add("PruebaXMLBiestable", this);
			}
	};
	PruebaXMLBiestable *prBiestable=new PruebaXMLBiestable();	
}
