#include "unit++.h"
#include "electroiman.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLElectroiman : public suite
	{
		void PruebaValoresElectroiman()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un electroiman*/
			ficheroCorrecto	=	p->esValido ("xml\\electroiman.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Electroiman obtenido" << endl;
				/* 	En este punto deberia haber un contador dentro del
					sistema. El biestable de este fichero se llama 
					"B1" (no modificar los ficheros de test del
					directorio xml) */
				Electroiman* e = (Electroiman*)
					sistemaParseado->getRefElementoPorNombre("Electroiman");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores a mano...*/	
				Voltaje*  	v1 = new Voltaje  (0.0);
				Voltaje*  	v2 = new Voltaje  (5.0);
				Magnetismo* m1 = new Magnetismo (false);
				Magnetismo* m2 = new Magnetismo (true);
				
				//Valores que leemos y compararemos con los construidos
				//para comprobar si son iguales
				Voltaje*	vEntradaReposo;
				Voltaje*	vEntradaActivacion;
				Magnetismo* magSalidaReposo;
				Magnetismo* magSalidaActivacion;
				
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vEntradaReposo = e->getVoltajeEntradaReposo();
				assert_eq ("(XML) Voltaje entrada reposo en electroiman", 
					vEntradaReposo->getValor(), v2->getValor() );
					
				vEntradaActivacion = e->getVoltajeEntradaActivacion();
				assert_eq ("(XML) Voltaje entrada activacion en electroiman", 
					vEntradaActivacion->getValor(), v1->getValor() );
				
				magSalidaReposo = e->getMagSalidaReposo();
				assert_eq ("(XML) Voltaje entrada activacion en electroiman", 
					magSalidaReposo->getValor(), m2->getValor() );
				
				magSalidaActivacion = e->getMagSalidaActivacion();
				assert_eq ("(XML) Voltaje entrada activacion en electroiman", 
					magSalidaActivacion->getValor(), m1->getValor() );
				p->escribir ( e, "xml-resultadoTest-xmlelectroiman.xml" );
				delete p;
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLElectroiman() : suite ("Prueba del XML del electroiman")
			{
				add ("PruebaXMLElectroiman", testcase (this,
					"PruebaXMLElectroiman", 
					&PruebaXMLElectroiman::PruebaValoresElectroiman) );
				
				suite::main().add("PruebaXMLElectroiman", this);
			}
	};
	PruebaXMLElectroiman *prElectroiman=new PruebaXMLElectroiman();	
}
